--- check_icmp.c.orig	2007-12-11 06:57:35.000000000 +0100
+++ check_icmp.c	2007-12-20 09:19:42.000000000 +0100
@@ -72,6 +72,7 @@
 #include <netinet/ip_icmp.h>
 #include <arpa/inet.h>
 #include <signal.h>
+#include <netinet/in.h>
 
 
 /** sometimes undefined system macros (quite a few, actually) **/
@@ -185,6 +186,7 @@
 static void run_checks(void);
 static int add_target(char *);
 static int add_target_ip(char *, struct in_addr *);
+static int add_source_ip(char *);
 static int handle_random_icmp(struct icmp *, struct sockaddr_in *);
 static unsigned short icmp_checksum(unsigned short *, int);
 static void finish(int);
@@ -446,7 +448,7 @@
 
 	/* parse the arguments */
 	for(i = 1; i < argc; i++) {
-		while((arg = getopt(argc, argv, "vhVw:c:n:p:t:H:i:b:I:l:m:")) != EOF) {
+		while((arg = getopt(argc, argv, "vhVw:c:n:p:t:H:S:i:b:I:l:m:")) != EOF) {
 			switch(arg) {
 			case 'v':
 				debug++;
@@ -489,6 +491,9 @@
 					crit_down = (unsigned char)strtoul(ptr + 1, NULL, 0);
 				}
 				break;
+			case 'S': /* specify source ip for ping */
+				add_source_ip(optarg);
+				break;
       case 'V':                 /* version */
         /*print_revision (progname, revision);*/ /* FIXME: Why? */
         exit (STATE_OK);
@@ -1109,6 +1114,28 @@
 
 	return 0;
 }
+
+static int
+add_source_ip(char *arg)
+{
+	struct in_addr ip;
+
+	if((ip.s_addr = inet_addr(arg)) != INADDR_NONE) {
+		struct sockaddr_in src;
+		src.sin_family = AF_INET;
+		src.sin_addr.s_addr = ip.s_addr;
+		src.sin_port = htons(0);
+		if (bind(icmp_sock, (struct sockaddr *) &src, sizeof(struct sockaddr_un)) == -1) {
+			crash("Could not bind to ipaddress %s", arg);
+		}
+	}
+	else {
+		crash("%s ist not a valid ip to use", arg);
+	}
+
+	return 0;
+}
+
 /*
  * u = micro
  * m = milli
@@ -1225,6 +1252,8 @@
   
   printf (" %s\n", "-H");
   printf ("    %s\n", _("specify a target"));
+  printf (" %s\n", "-S");
+  printf ("    %s\n", _("specify a source ip address)"));
   printf (" %s\n", "-w");
   printf ("    %s", _("warning threshold (currently "));
   printf ("%0.3fms,%u%%)\n", (float)warn.rta / 1000 , warn.pl / 1000);
